> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://help.sigmacomputing.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://help.sigmacomputing.com/_mcp/server.

# Swap data model sources

POST https://api.sigmacomputing.com/v2/dataModels/{dataModelId}/swapSources
Content-Type: application/json

Swap the data sources used by a data model. You can swap from one connection to another, and/or from one dataset or table to another.

### Usage notes

* Retrieve the **dataModelId** by calling the [/v2/dataModels](https://help.sigmacomputing.com/reference/list-data-models) endpoint.

* Retrieve the **connectionId** by calling the [/v2/connections](https://help.sigmacomputing.com/reference/list-connections) endpoint.

* To map the sources of a specific element, you can use the table or dataset ID:

  * List sources of data model by calling the [/v2/dataModels/\{dataModelId}/sources](https://help.sigmacomputing.com/reference/list-data-model-sources) endpoint.
  * Retrieve table and dataset IDs by calling the [/v2/files](https://help.sigmacomputing.com/reference/list-files) endpoint. Use the `typeFilters` option to filter for table and dataset files. Use `id` field in the response as the `fromId` or `toId`, as relevant.

* To swap all tables in a connection, set the `swapTables` option to `true`.

  * Use the `paths` option to specify the connection paths to swap. The connection path is a list of strings that represents the path to the table in the cloud data warehouse. For example, `["database", "schema", "table"]`.
  * If the table schema is the same in both connections, leave the `paths` option empty to swap all tables in the connection. You can also pass a partial path to swap between databases, catalogs, or schemas.
  * If `sourceMapping` is provided, those mappings take precedence over the connection swaps.
  * If `swapTables` is not set to `true`, only Custom SQL elements have their connections changed.

### Usage scenarios

* **Data model development**: Use a test data source while developing a data model, then swap the source to a production database when ready to share the data model for production use.

Reference: https://help.sigmacomputing.com/reference/swap-data-model-sources

## Authentication

- OAuth2 — send the obtained token as `Authorization: Bearer <token>`

## Servers

- `https://api.sigmacomputing.com` (Server for GCP (US) hosted organizations, default)
- `https://api.sa.gcp.sigmacomputing.com` (Server for GCP (KSA) hosted organizations)
- `https://aws-api.sigmacomputing.com` (Server for AWS US (West) hosted organizations)
- `https://api.us-a.aws.sigmacomputing.com` (Server for AWS US (East) hosted organizations)
- `https://api.ca.aws.sigmacomputing.com` (Server for AWS Canada hosted organizations)
- `https://api.eu.aws.sigmacomputing.com` (Server for AWS Europe hosted organizations)
- `https://api.au.aws.sigmacomputing.com` (Server for AWS Australia and APAC hosted organizations)
- `https://api.uk.aws.sigmacomputing.com` (Server for AWS UK hosted organizations)
- `https://api.us.azure.sigmacomputing.com` (Server for Azure US hosted organizations)
- `https://api.eu.azure.sigmacomputing.com` (Server for Azure Europe hosted organizations)
- `https://api.ca.azure.sigmacomputing.com` (Server for Azure Canada hosted organizations)
- `https://api.uk.azure.sigmacomputing.com` (Server for Azure United Kingdom hosted organizations)
- `https://api.au.azure.sigmacomputing.com` (Server for Azure Australia hosted organizations)

## Request

### Path parameters

- `dataModelId` (string, required)

### Body (application/json)

- `sourceMapping` (list of object, optional)
  - `fromId` (string, required) — ID of the dataset (deprecated) or table to swap from.
  - `toId` (string, required) — ID of the dataset (deprecated) or table to swap to.
  - `metricMapping` (list of object, optional)
    - `fromMetric` (string, required) — Metric in the data source.
    - `toMetric` (string, required) — Metric in the data source.
  - `columnMapping` (list of object, optional)
    - `fromColumn` (string or list of string, required)
    - `toColumn` (string or list of string, required)
- `connectionMapping` (list of object, optional)
  - `fromId` (string, required) — ID of the connection to swap from.
  - `toId` (string, required) — ID of the connection to swap to.
  - `swapTables` (boolean, optional) — Whether to swap all tables in the connection
  - `paths` (list of object, optional)
    - `fromPath` (list of string, required) — Connection path of the form ['DATABASE', 'SCHEMA', 'TABLE']
    - `toPath` (list of string, required) — Connection path of the form ['DATABASE', 'SCHEMA', 'TABLE']
- `copyInputTableData` (boolean, optional)

## Response

### 200

The response body.

- `unswappedSources` (list of string, required) — IDs of sources in the workbook that were not swapped.
- `unswappedConnections` (list of string, required) — IDs of custom SQL connections in the workbook that were not swapped.

## Examples

**Request**

```json
{}
```

**Response**

```json
{
  "unswappedSources": [
    "string"
  ],
  "unswappedConnections": [
    "string"
  ]
}
```

**SDK Code**

```python
import requests

url = "https://api.sigmacomputing.com/v2/dataModels/dataModelId/swapSources"

payload = {}
headers = {
    "Authorization": "<token>.",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.sigmacomputing.com/v2/dataModels/dataModelId/swapSources';
const options = {
  method: 'POST',
  headers: {Authorization: '<token>.', 'Content-Type': 'application/json'},
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.sigmacomputing.com/v2/dataModels/dataModelId/swapSources"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "<token>.")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.sigmacomputing.com/v2/dataModels/dataModelId/swapSources")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = '<token>.'
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.sigmacomputing.com/v2/dataModels/dataModelId/swapSources")
  .header("Authorization", "<token>.")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.sigmacomputing.com/v2/dataModels/dataModelId/swapSources', [
  'body' => '{}',
  'headers' => [
    'Authorization' => '<token>.',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.sigmacomputing.com/v2/dataModels/dataModelId/swapSources");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "<token>.");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "<token>.",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.sigmacomputing.com/v2/dataModels/dataModelId/swapSources")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```